Index: .hgtags
===================================================================
--- .hgtags	(revision 800)
+++ .hgtags	(revision 871)
@@ -6,2 +6,8 @@
 0000000000000000000000000000000000000000 2.4.2
 6b3942c0cf7eee71ebd906ec0827c5962823dedf 2.4.2
+36578fa779919f730e714e10041b1f896e56a8f4 2.4.3
+7f3781b97754446cd2bd5dab96fec504e2b35ca5 2.4.4
+7f3781b97754446cd2bd5dab96fec504e2b35ca5 2.4.4
+6fce226121140735a51a8f447c80f1dacd2974ea 2.4.4
+6fce226121140735a51a8f447c80f1dacd2974ea 2.4.4
+514d5121a12586b7ff320924d44028b677a01020 2.4.4
Index: CHANGELOG
===================================================================
--- CHANGELOG	(revision 978)
+++ CHANGELOG	(revision 1011)
@@ -1,4 +1,5 @@
 Dotclear 2.5.0 - 201?-??-13
 ===========================================================
+* Every types of entries may be used to inserted an entry link in current edited post
 * Add (none) option to image insertion title pattern
 * Smileys are not more converted in image in pre,code,kbd,script and math contents
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 907)
+++ admin/categories.php	(revision 1015)
@@ -20,4 +20,5 @@
 	try
 	{
+		# Check if category to delete exists
 		$c = $core->blog->getCategory((integer) $_POST['del_cat']);
 		if ($c->isEmpty()) {
@@ -25,5 +26,22 @@
 		}
 		unset($c);
+		
+		# Check if category where to move posts exists
+		$mov_cat = (integer) $_POST['mov_cat'];
+		$mov_cat = $mov_cat ? $mov_cat : null;
+		if ($mov_cat !== null) {
+			$c = $core->blog->getCategory((integer) $_POST['del_cat']);
+			if ($c->isEmpty()) {
+				throw new Exception(__('This category does not exist.'));
+			}
+			unset($c);
+		}
+		
+		# Move posts
+		$core->blog->updPostsCategory($_POST['del_cat'],$mov_cat);
+		
+		# Delete category
 		$core->blog->delCategory($_POST['del_cat']);
+		
 		http::redirect('categories.php?del=1');
 	}
@@ -143,5 +161,6 @@
 if (!$rs->isEmpty())
 {
-	$deletable = array();
+	$cats = array();
+	$dest = array('&nbsp;' => '');
 	$l = $rs->level;
 	$full_name = array($rs->cat_title);
@@ -154,22 +173,22 @@
 		}
 		$full_name[] = html::escapeHTML($rs->cat_title);
-		if ($rs->nb_post == 0) {
-			$deletable[implode(' / ',$full_name)] = $rs->cat_id;
-		}
+		
+		$cats[implode(' / ',$full_name)] = $rs->cat_id;
+		$dest[implode(' / ',$full_name)] = $rs->cat_id;
+		
 		$l = $rs->level;
 	}
 	
-	if (count($deletable) > 0)
-	{
-		echo
-		'<form action="categories.php" method="post" id="delete-category">'.
-		'<fieldset><legend>'.__('Remove a category').'</legend>'.
-		'<p><label for="del_cat">'.__('Choose a category to remove:').' '.
-		form::combo('del_cat',$deletable).'</label></p> '.
-		'<p><input type="submit" value="'.__('Delete').'" class="delete" /></p>'.
-		$core->formNonce().
-		'</fieldset>'.
-		'</form>';
-	}
+	echo
+	'<form action="categories.php" method="post" id="delete-category">'.
+	'<fieldset><legend>'.__('Remove a category').'</legend>'.
+	'<p><label for="del_cat">'.__('Choose a category to remove:').' '.
+	form::combo('del_cat',$cats).'</label></p> '.
+	'<p><label for="mov_cat">'.__('Move its content to another category:').' '.
+	form::combo('mov_cat',$dest).'</label></p> '.
+	'<p><input type="submit" value="'.__('Delete').'" class="delete" /></p>'.
+	$core->formNonce().
+	'</fieldset>'.
+	'</form>';
 	
 	echo
Index: admin/index.php
===================================================================
--- admin/index.php	(revision 931)
+++ admin/index.php	(revision 1000)
@@ -156,5 +156,5 @@
 			foreach ($feed->items as $item)
 			{
-				$dt = isset($item->link) ? '<a href="'.$item->link.'"'.$v.'" title="'.$item->title.' '.__('(external link)').'">'.
+				$dt = isset($item->link) ? '<a href="'.$item->link.'" title="'.$item->title.' '.__('(external link)').'">'.
 					$item->title.'</a>' : $item->title;
 			
@@ -162,10 +162,10 @@
 					$latest_news .=
 					'<dt>'.$dt.'</dt>'.
-					'<dd><p><strong>'.dt::dt2str('%d %B %Y',$item->pubdate,'Europe/Paris').'</strong>: '.
+					'<dd><p><strong>'.dt::dt2str(__('%d %B %Y:'),$item->pubdate,'Europe/Paris').'</strong> '.
 					'<em>'.text::cutString(html::clean($item->content),120).'...</em></p></dd>';
 				} else {
 					$latest_news .=
 					'<dt>'.$dt.'</dt>'.
-					'<dd>'.dt::dt2str('%d %B %Y',$item->pubdate,'Europe/Paris').'</dd>';
+					'<dd>'.dt::dt2str(__('%d %B %Y:'),$item->pubdate,'Europe/Paris').'</dd>';
 				}
 				$i++;
Index: admin/js/_posts_list.js
===================================================================
--- admin/js/_posts_list.js	(revision 740)
+++ admin/js/_posts_list.js	(revision 995)
@@ -69,4 +69,9 @@
 
 $(function() {
+	// Entry type switcher
+	$('#type').change(function() {
+		this.form.submit();
+	});
+
 	$('#form-entries tr.line').each(function() {
 		dotclear.postExpander(this);
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 958)
+++ admin/js/common.js	(revision 1002)
@@ -159,6 +159,6 @@
 	var sizeBox = function() {
 		This.css('height','auto');
-		if ($('body').height() > This.height()) {
-			This.css('height',$('body').height() + 'px');
+		if ($('#main').height() > This.height()) {
+			This.css('height',$('#main').height() + 'px');
 		}
 	};
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 950)
+++ admin/media_item.php	(revision 1011)
@@ -293,7 +293,7 @@
 		echo
 		'<h3>'.__('Video size').'</h3>'.
-		'<p><label for="video_w" class="classic">'.__('Width:').' '.
+		'<p><label for="video_w" class="classic">'.__('Width:').'</label> '.
 		form::field('video_w',3,4,400).'  '.
-		'<label for="video_h" class="classic">'.__('Height:').' '.
+		'<label for="video_h" class="classic">'.__('Height:').'</label> '.
 		form::field('video_h',3,4,300).
 		'</p>';
Index: admin/popup_posts.php
===================================================================
--- admin/popup_posts.php	(revision 557)
+++ admin/popup_posts.php	(revision 996)
@@ -20,4 +20,17 @@
 $nb_per_page =  10;
 
+$post_types = $core->getPostTypes();
+foreach ($post_types as $k => $v) {
+ 	$type_combo[__($k)] = (string) $k;
+}
+$type = !empty($_POST['type']) ? $_POST['type'] : null;
+if (!$type && $q) {
+	// Cope with search form
+	$type = !empty($_GET['type']) ? $_GET['type'] : null;
+}
+if (!in_array($type, $type_combo)) {
+	$type = null;
+}
+
 $params = array();
 $params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
@@ -29,4 +42,8 @@
 }
 
+if ($type) {
+	$params['post_type'] = $type;
+}
+
 dcPage::openPopup(__('Add a link to an entry'),
 	dcPage::jsLoad('js/_posts_list.js').
@@ -35,8 +52,15 @@
 echo '<h2 class="page-title">'.__('Add a link to an entry').'</h2>';
 
+echo '<form action="popup_posts.php" method="post">'.
+	'<p><label for"type" class="classic">'.__('Entry type:').' '.form::combo('type',$type_combo,$type).'</label></p>'.
+	$core->formNonce().
+	'<noscript><div><input type="submit" value="'.__('Ok').'" /></div></noscript>'.
+	'</form>';
+
 echo '<form action="popup_posts.php" method="get">'.
-'<p><label for="q" class="classic">'.__('Search entry:').' '.form::field('q',30,255,html::escapeHTML($q)).'</label> '.
-' <input type="submit" value="'.__('Search').'" /></p>'.
-'</form>';
+	'<p><label for="q" class="classic">'.__('Search entry:').' '.form::field('q',30,255,html::escapeHTML($q)).'</label> '.
+	' <input type="submit" value="'.__('Search').'" /></p>'.
+	form::hidden('type',html::escapeHTML($type)).
+	'</form>';
 
 try {
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 1014)
+++ admin/post.php	(revision 957)
@@ -14,4 +14,23 @@
 
 dcPage::check('usage,contentadmin');
+
+$post_id = '';
+$cat_id = '';
+$post_dt = '';
+$post_format = $core->auth->getOption('post_format');
+$post_password = '';
+$post_url = '';
+$post_lang = $core->auth->getInfo('user_lang');
+$post_title = '';
+$post_excerpt = '';
+$post_excerpt_xhtml = '';
+$post_content = '';
+$post_content_xhtml = '';
+$post_notes = '';
+$post_status = $core->auth->getInfo('user_post_status');
+$post_selected = false;
+$post_open_comment = $core->blog->settings->system->allow_comments;
+$post_open_tb = $core->blog->settings->system->allow_trackbacks;
+
 $page_title = __('New entry');
 
@@ -28,5 +47,5 @@
 # If user can't publish
 if (!$can_publish) {
-	$form->post_status = -2;
+	$post_status = -2;
 }
 
@@ -45,6 +64,7 @@
 # Status combo
 foreach ($core->blog->getAllPostStatus() as $k => $v) {
-	$status_combo[$k] = $v;
-}
+	$status_combo[$v] = (string) $k;
+}
+$img_status_pattern = '<img class="img_select_option" alt="%1$s" title="%1$s" src="images/%2$s" />';
 
 # Formaters combo
@@ -68,56 +88,6 @@
 unset($rs);
 
-
-
-$form = new dcForm($core,'post','post.php');
-$form
-	->addField(
-		new dcFieldText('post_title','', array(
-			'size'		=> 20,
-			'required'	=> true,
-			'label'		=> __('Title'))))
-	->addField(
-		new dcFieldTextArea('post_excerpt','', array(
-			'cols'		=> 50,
-			'rows'		=> 5,
-			'label'		=> __("Excerpt:"))))
-	->addField(
-		new dcFieldTextArea('post_content','', array(
-			'required'	=> true,
-			'label'		=> __("Content:"))))
-	->addField(
-		new dcFieldTextArea('post_notes','', array(
-			'label'		=> __("Notes"))))
-	->addField(
-		new dcFieldSubmit('save',__('Save'),array()))
-	->addField(
-		new dcFieldSubmit('delete',__('Delete'),array()))
-	->addField(
-		new dcFieldCombo('post_status',$core->auth->getInfo('user_post_status'),$status_combo,array(
-			'disabled' => !$can_publish,
-			'label' => __('Entry status:'))))
-	->addField(
-		new dcFieldCombo('cat_id','',$categories_combo,array(
-			"label" => __('Category:'))))
-	->addField(
-		new dcFieldText('post_dt','',array(
-			"label" => __('Published on:'))))
-	->addField(
-		new dcFieldCombo('post_format',$core->auth->getOption('post_format'),$formaters_combo,array(
-			"label" => __('Text formating:'))))
-	->addField(
-		new dcFieldCheckbox ('post_open_comment',$core->blog->settings->system->allow_comments,array(
-			"label" => __('Accept comments'))))
-	->addField(
-		new dcFieldCheckbox ('post_open_tb',$core->blog->settings->system->allow_trackbacks,array(
-			"label" => __('Accept trackbacks'))))
-	->addField(
-		new dcFieldCheckbox ('post_selected',false,array(
-			"label" => __('Selected entry'))))
-	->addField(
-		new dcFieldCombo ('post_lang',$core->auth->getInfo('user_lang'),$lang_combo, array(
-			"label" => __('Entry lang:'))))
-;
-
+# Validation flag
+$bad_dt = false;
 
 # Get entry informations
@@ -135,21 +105,21 @@
 	else
 	{
-		$form->post_id = $post->post_id;
-		$form->cat_id = $post->cat_id;
-		$form->post_dt = date('Y-m-d H:i',strtotime($post->post_dt));
-		$form->post_format = $post->post_format;
-		$form->post_password = $post->post_password;
-		$form->post_url = $post->post_url;
-		$form->post_lang = $post->post_lang;
-		$form->post_title = $post->post_title;
-		$form->post_excerpt = $post->post_excerpt;
+		$post_id = $post->post_id;
+		$cat_id = $post->cat_id;
+		$post_dt = date('Y-m-d H:i',strtotime($post->post_dt));
+		$post_format = $post->post_format;
+		$post_password = $post->post_password;
+		$post_url = $post->post_url;
+		$post_lang = $post->post_lang;
+		$post_title = $post->post_title;
+		$post_excerpt = $post->post_excerpt;
 		$post_excerpt_xhtml = $post->post_excerpt_xhtml;
-		$form->post_content = $post->post_content;
+		$post_content = $post->post_content;
 		$post_content_xhtml = $post->post_content_xhtml;
-		$form->post_notes = $post->post_notes;
-		$form->post_status = $post->post_status;
-		$form->post_selected = (boolean) $post->post_selected;
-		$form->post_open_comment = (boolean) $post->post_open_comment;
-		$form->post_open_tb = (boolean) $post->post_open_tb;
+		$post_notes = $post->post_notes;
+		$post_status = $post->post_status;
+		$post_selected = (boolean) $post->post_selected;
+		$post_open_comment = (boolean) $post->post_open_comment;
+		$post_open_tb = (boolean) $post->post_open_tb;
 		
 		$page_title = __('Edit entry');
@@ -199,6 +169,17 @@
 		$post_dt = '';
 	} else {
-		$post_dt = strtotime($_POST['post_dt']);
-		$post_dt = date('Y-m-d H:i',$post_dt);
+		try
+		{
+			$post_dt = strtotime($_POST['post_dt']);
+			if ($post_dt == false || $post_dt == -1) {
+				$bad_dt = true;
+				throw new Exception(__('Invalid publication date'));
+			}
+			$post_dt = date('Y-m-d H:i',$post_dt);
+		}
+		catch (Exception $e)
+		{
+			$core->error->add($e->getMessage());
+		}
 	}
 	
@@ -222,5 +203,5 @@
 
 # Create or update post
-if (!empty($_POST) && !empty($_POST['save']) && $can_edit_post)
+if (!empty($_POST) && !empty($_POST['save']) && $can_edit_post && !$bad_dt)
 {
 	$cur = $core->con->openCursor($core->prefix.'post');
@@ -312,14 +293,393 @@
 }
 
-$core->page->getContext()
-	->jsDatePicker()
-	->jsToolBar()
-	->jsModal()
-	->jsMetaEditor()
-	->jsLoad('js/_post.js')
-	->jsPageTabs($default_tab)
-	->jsConfirmClose('entry-form','comment-form');
-
-echo $core->page->render('post.html.twig',array(
-	'edit_size'=> $core->auth->getOption('edit_size')));
+dcPage::open($page_title.' - '.__('Entries'),
+	dcPage::jsDatePicker().
+	dcPage::jsToolBar().
+	dcPage::jsModal().
+	dcPage::jsMetaEditor().
+	dcPage::jsLoad('js/_post.js').
+	dcPage::jsConfirmClose('entry-form','comment-form').
+	# --BEHAVIOR-- adminPostHeaders
+	$core->callBehavior('adminPostHeaders').
+	dcPage::jsPageTabs($default_tab).
+	$next_headlink."\n".$prev_headlink
+);
+
+if (!empty($_GET['upd'])) {
+	dcPage::message(__('Entry has been successfully updated.'));
+}
+elseif (!empty($_GET['crea'])) {
+	dcPage::message(__('Entry has been successfully created.'));
+}
+elseif (!empty($_GET['attached'])) {
+	dcPage::message(__('File has been successfully attached.'));
+}
+elseif (!empty($_GET['rmattach'])) {
+	dcPage::message(__('Attachment has been successfully removed.'));
+}
+
+if (!empty($_GET['creaco'])) {
+	dcPage::message(__('Comment has been successfully created.'));
+}
+
+# XHTML conversion
+if (!empty($_GET['xconv']))
+{
+	$post_excerpt = $post_excerpt_xhtml;
+	$post_content = $post_content_xhtml;
+	$post_format = 'xhtml';
+	
+	dcPage::message(__('Don\'t forget to validate your XHTML conversion by saving your post.'));
+}
+
+echo '<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; '.'<a href="posts.php">'.__('Entries').'</a> &rsaquo; <span class="page-title">'.$page_title;
+if ($post_id) {
+	switch ($post_status) {
+		case 1:
+			$img_status = sprintf($img_status_pattern,__('published'),'check-on.png');
+			break;
+		case 0:
+			$img_status = sprintf($img_status_pattern,__('unpublished'),'check-off.png');
+			break;
+		case -1:
+			$img_status = sprintf($img_status_pattern,__('scheduled'),'scheduled.png');
+			break;
+		case -2:
+			$img_status = sprintf($img_status_pattern,__('pending'),'check-wrn.png');
+			break;
+		default:
+			$img_status = '';
+	}
+	echo ' &ldquo;'.$post_title.'&rdquo;'.' '.$img_status;
+}
+echo	'</span></h2>';
+
+if ($post_id && $post->post_status == 1) {
+	echo '<p><a href="'.$post->getURL().'" onclick="window.open(this.href);return false;" title="'.$post_title.' ('.__('new window').')'.'">'.__('Go to this entry on the site').' <img src="images/outgoing-blue.png" alt="" /></a></p>';
+}
+if ($post_id)
+{
+	echo '<p>';
+	if ($prev_link) { echo $prev_link; }
+	if ($next_link && $prev_link) { echo ' - '; }
+	if ($next_link) { echo $next_link; }
+	
+	# --BEHAVIOR-- adminPostNavLinks
+	$core->callBehavior('adminPostNavLinks',isset($post) ? $post : null);
+	
+	echo '</p>';
+}
+
+# Exit if we cannot view page
+if (!$can_view_page) {
+	dcPage::helpBlock('core_post');
+	dcPage::close();
+	exit;
+}
+
+/* Post form if we can edit post
+-------------------------------------------------------- */
+if ($can_edit_post)
+{
+	echo '<div class="multi-part" title="'.__('Edit entry').'" id="edit-entry">';
+	echo '<form action="post.php" method="post" id="entry-form">';
+	echo '<div id="entry-wrapper">';
+	echo '<div id="entry-content"><div class="constrained">';
+	
+	echo
+	'<p class="col"><label class="required"><abbr title="'.__('Required field').'">*</abbr> '.__('Title:').
+	form::field('post_title',20,255,html::escapeHTML($post_title),'maximal').
+	'</label></p>'.
+	
+	'<p class="area" id="excerpt-area"><label for="post_excerpt">'.__('Excerpt:').'</label> '.
+	form::textarea('post_excerpt',50,5,html::escapeHTML($post_excerpt)).
+	'</p>'.
+	
+	'<p class="area"><label class="required" '.
+	'for="post_content"><abbr title="'.__('Required field').'">*</abbr> '.__('Content:').'</label> '.
+	form::textarea('post_content',50,$core->auth->getOption('edit_size'),html::escapeHTML($post_content)).
+	'</p>'.
+	
+	'<p class="area" id="notes-area"><label for="post_notes">'.__('Notes:').'</label>'.
+	form::textarea('post_notes',50,5,html::escapeHTML($post_notes)).
+	'</p>';
+	
+	# --BEHAVIOR-- adminPostForm
+	$core->callBehavior('adminPostForm',isset($post) ? $post : null);
+	
+	echo
+	'<p>'.
+	($post_id ? form::hidden('id',$post_id) : '').
+	'<input type="submit" value="'.__('Save').' (s)" '.
+	'accesskey="s" name="save" /> ';
+	if ($post_id) {
+		$preview_url =
+		$core->blog->url.$core->url->getURLFor('preview',$core->auth->userID().'/'.
+		http::browserUID(DC_MASTER_KEY.$core->auth->userID().$core->auth->getInfo('user_pwd')).
+		'/'.$post->post_url);
+		echo '<a id="post-preview" href="'.$preview_url.'" class="button">'.__('Preview').'</a> ';
+	}
+	echo
+	($can_delete ? '<input type="submit" class="delete" value="'.__('Delete').'" name="delete" />' : '').
+	$core->formNonce().
+	'</p>';
+	
+	echo '</div></div>';		// End #entry-content
+	echo '</div>';		// End #entry-wrapper
+
+	echo '<div id="entry-sidebar">';
+	
+	echo
+	'<p><label for="cat_id">'.__('Category:').
+	form::combo('cat_id',$categories_combo,$cat_id,'maximal').
+	'</label></p>'.
+	
+	'<p><label for="post_status">'.__('Entry status:').
+	form::combo('post_status',$status_combo,$post_status,'','',!$can_publish).
+	'</label></p>'.
+	
+	'<p><label for="post_dt">'.__('Published on:').
+	form::field('post_dt',16,16,$post_dt,($bad_dt ? 'invalid' : '')).
+	'</label></p>'.
+	
+	'<p><label for="post_format">'.__('Text formating:').
+	form::combo('post_format',$formaters_combo,$post_format).
+	'</label>'.
+	'</p>'.
+	'<p>'.($post_id && $post_format != 'xhtml' ? '<a id="convert-xhtml" class="button" href="post.php?id='.$post_id.'&amp;xconv=1">'.__('Convert to XHTML').'</a>' : '').'</p>'.
+	
+	'<p><label for="post_open_comment" class="classic">'.form::checkbox('post_open_comment',1,$post_open_comment).' '.
+	__('Accept comments').'</label></p>'.
+	($core->blog->settings->system->allow_comments ? 
+		(isContributionAllowed($post_id,strtotime($post_dt),true) ? 
+			'' :
+			'<p class="form-note warn">'.__('Warning: Comments are not more accepted for this entry.').'</p>') : 
+		'<p class="form-note warn">'.__('Warning: Comments are not accepted on this blog.').'</p>').
+
+	'<p><label for="post_open_tb" class="classic">'.form::checkbox('post_open_tb',1,$post_open_tb).' '.
+	__('Accept trackbacks').'</label></p>'.
+	($core->blog->settings->system->allow_trackbacks ? 
+		(isContributionAllowed($post_id,strtotime($post_dt),false) ? 
+			'' :
+			'<p class="form-note warn">'.__('Warning: Trackbacks are not more accepted for this entry.').'</p>') : 
+		'<p class="form-note warn">'.__('Warning: Trackbacks are not accepted on this blog.').'</p>').
+
+	'<p><label for="post_selected" class="classic">'.form::checkbox('post_selected',1,$post_selected).' '.
+	__('Selected entry').'</label></p>'.
+	
+	'<p><label for="post_lang">'.__('Entry lang:').
+	form::combo('post_lang',$lang_combo,$post_lang).
+	'</label></p>'.
+	
+	'<p><label for="post_password">'.__('Entry password:').
+	form::field('post_password',10,32,html::escapeHTML($post_password),'maximal').
+	'</label></p>'.
+	
+	'<div class="lockable">'.
+	'<p><label for="post_url">'.__('Basename:').
+	form::field('post_url',10,255,html::escapeHTML($post_url),'maximal').
+	'</label></p>'.
+	'<p class="form-note warn">'.
+	__('Warning: If you set the URL manually, it may conflict with another entry.').
+	'</p>'.
+	'</div>';
+	
+	# --BEHAVIOR-- adminPostFormSidebar
+	$core->callBehavior('adminPostFormSidebar',isset($post) ? $post : null);
+	
+	echo '</div>';		// End #entry-sidebar
+
+	echo '</form>';
+	
+	# --BEHAVIOR-- adminPostForm
+	$core->callBehavior('adminPostAfterForm',isset($post) ? $post : null);
+	
+	echo '</div>';
+	
+	if ($post_id && $post->post_status == 1) {
+		echo '<p><a href="trackbacks.php?id='.$post_id.'" class="multi-part">'.
+		__('Ping blogs').'</a></p>';
+	}
+	
+}
+
+
+/* Comments and trackbacks
+-------------------------------------------------------- */
+if ($post_id)
+{
+	$params = array('post_id' => $post_id, 'order' => 'comment_dt ASC');
+	
+	$comments = $core->blog->getComments(array_merge($params,array('comment_trackback'=>0)));
+	$trackbacks = $core->blog->getComments(array_merge($params,array('comment_trackback'=>1)));
+	
+	# Actions combo box
+	$combo_action = array();
+	if ($can_edit_post && $core->auth->check('publish,contentadmin',$core->blog->id))
+	{
+		$combo_action[__('publish')] = 'publish';
+		$combo_action[__('unpublish')] = 'unpublish';
+		$combo_action[__('mark as pending')] = 'pending';
+		$combo_action[__('mark as junk')] = 'junk';
+	}
+	
+	if ($can_edit_post && $core->auth->check('delete,contentadmin',$core->blog->id))
+	{
+		$combo_action[__('Delete')] = 'delete';
+	}
+	
+	# --BEHAVIOR-- adminCommentsActionsCombo
+	$core->callBehavior('adminCommentsActionsCombo',array(&$combo_action));
+	
+	$has_action = !empty($combo_action) && (!$trackbacks->isEmpty() || !$comments->isEmpty());
+	
+	echo
+	'<div id="comments" class="multi-part" title="'.__('Comments').'">';
+	
+	if ($has_action) {
+		echo '<form action="comments_actions.php" id="form-comments" method="post">';
+	}
+	
+	echo '<h3>'.__('Trackbacks').'</h3>';
+	
+	if (!$trackbacks->isEmpty()) {
+		showComments($trackbacks,$has_action,true);
+	} else {
+		echo '<p>'.__('No trackback').'</p>';
+	}
+	
+	echo '<h3>'.__('Comments').'</h3>';
+	if (!$comments->isEmpty()) {
+		showComments($comments,$has_action);
+	} else {
+		echo '<p>'.__('No comment').'</p>';
+	}
+	
+	if ($has_action) {
+		echo
+		'<div class="two-cols">'.
+		'<p class="col checkboxes-helpers"></p>'.
+		
+		'<p class="col right"><label for="action" class="classic">'.__('Selected comments action:').'</label> '.
+		form::combo('action',$combo_action).
+		form::hidden('redir','post.php?id='.$post_id.'&amp;co=1').
+		$core->formNonce().
+		'<input type="submit" value="'.__('ok').'" /></p>'.
+		'</div>'.
+		'</form>';
+	}
+	
+	echo '</div>';
+}
+
+/* Add a comment
+-------------------------------------------------------- */
+if ($post_id)
+{
+	echo
+	'<div class="multi-part" id="add-comment" title="'.__('Add a comment').'">'.
+	'<h3>'.__('Add a comment').'</h3>'.
+	
+	'<form action="comment.php" method="post" id="comment-form">'.
+	'<div class="constrained">'.
+	'<p><label for="comment_author" class="required"><abbr title="'.__('Required field').'">*</abbr> '.__('Name:').
+	form::field('comment_author',30,255,html::escapeHTML($core->auth->getInfo('user_cn'))).
+	'</label></p>'.
+	
+	'<p><label for="comment_email">'.__('Email:').
+	form::field('comment_email',30,255,html::escapeHTML($core->auth->getInfo('user_email'))).
+	'</label></p>'.
+	
+	'<p><label for="comment_site">'.__('Web site:').
+	form::field('comment_site',30,255,html::escapeHTML($core->auth->getInfo('user_url'))).
+	'</label></p>'.
+	
+	'<p class="area"><label for="comment_content" class="required"><abbr title="'.__('Required field').'">*</abbr> '.
+	__('Comment:').'</label> '.
+	form::textarea('comment_content',50,8,html::escapeHTML('')).
+	'</p>'.
+	
+	'<p>'.form::hidden('post_id',$post_id).
+	$core->formNonce().
+	'<input type="submit" name="add" value="'.__('Save').'" /></p>'.
+	'</div>'.
+	'</form>'.
+	'</div>';
+}
+
+# Controls comments or trakbacks capabilities
+function isContributionAllowed($id,$dt,$com=true)
+{
+	global $core;
+
+	if (!$id) {
+		return true;
+	}
+	if ($com) {
+		if (($core->blog->settings->system->comments_ttl == 0) || 
+			(time() - $core->blog->settings->system->comments_ttl*86400 < $dt)) {
+			return true;
+		}
+	} else {
+		if (($core->blog->settings->system->trackbacks_ttl == 0) || 
+			(time() - $core->blog->settings->system->trackbacks_ttl*86400 < $dt)) {
+			return true;
+		}
+	}
+	return false;
+}
+
+# Show comments or trackbacks
+function showComments($rs,$has_action,$tb=false)
+{
+	echo
+	'<table class="comments-list"><tr>'.
+	'<th colspan="2">'.__('Author').'</th>'.
+	'<th>'.__('Date').'</th>'.
+	'<th class="nowrap">'.__('IP address').'</th>'.
+	'<th>'.__('Status').'</th>'.
+	'<th>&nbsp;</th>'.
+	'</tr>';
+	
+	while($rs->fetch())
+	{
+		$comment_url = 'comment.php?id='.$rs->comment_id;
+		
+		$img = '<img alt="%1$s" title="%1$s" src="images/%2$s" />';
+		switch ($rs->comment_status) {
+			case 1:
+				$img_status = sprintf($img,__('published'),'check-on.png');
+				break;
+			case 0:
+				$img_status = sprintf($img,__('unpublished'),'check-off.png');
+				break;
+			case -1:
+				$img_status = sprintf($img,__('pending'),'check-wrn.png');
+				break;
+			case -2:
+				$img_status = sprintf($img,__('junk'),'junk.png');
+				break;
+		}
+		
+		echo
+		'<tr class="line'.($rs->comment_status != 1 ? ' offline' : '').'"'.
+		' id="c'.$rs->comment_id.'">'.
+		
+		'<td class="nowrap">'.
+		($has_action ? form::checkbox(array('comments[]'),$rs->comment_id,'','','',0,'title="'.($tb ? __('select this trackback') : __('select this comment')).'"') : '').'</td>'.
+		'<td class="maximal">'.html::escapeHTML($rs->comment_author).'</td>'.
+		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$rs->comment_dt).'</td>'.
+		'<td class="nowrap"><a href="comments.php?ip='.$rs->comment_ip.'">'.$rs->comment_ip.'</a></td>'.
+		'<td class="nowrap status">'.$img_status.'</td>'.
+		'<td class="nowrap status"><a href="'.$comment_url.'">'.
+		'<img src="images/edit-mini.png" alt="" title="'.__('Edit this comment').'" /></a></td>'.
+		
+		'</tr>';
+	}
+	
+	echo '</table>';
+}
+
+dcPage::helpBlock('core_post','core_wiki');
+dcPage::close();
 ?>
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 973)
+++ inc/admin/lib.dc.page.php	(revision 999)
@@ -57,5 +57,5 @@
 		{
 			$blog_box =
-			__('Blog:').' <strong title="'.html::escapeHTML($core->blog->url).'">'.
+			'<p>'.__('Blog:').' <strong title="'.html::escapeHTML($core->blog->url).'">'.
 			html::escapeHTML($core->blog->name).'</strong>';
 			
@@ -63,4 +63,5 @@
 				$blog_box .= ' - <a href="blogs.php">'.__('Change blog').'</a>';
 			}
+			$blog_box .= '</p>';
 		}
 		else
@@ -72,10 +73,10 @@
 			}
 			$blog_box =
-			'<label for="switchblog" class="classic">'.
+			'<p><label for="switchblog" class="classic">'.
 			__('Blogs:').' '.
 			$core->formNonce().
 			form::combo('switchblog',$blogs,$core->blog->id).
-			'</label>'.
-			'<noscript><div><input type="submit" value="'.__('ok').'" /></div></noscript>';
+			'</label></p>'.
+			'<noscript><p><input type="submit" value="'.__('ok').'" /></p></noscript>';
 		}
 		
@@ -132,6 +133,6 @@
 		'<form action="index.php" method="post">'.
 		$blog_box.
-		'<a href="'.$core->blog->url.'" onclick="window.open(this.href);return false;" title="'.__('Go to site').' ('.__('new window').')'.'">'.__('Go to site').' <img src="images/outgoing.png" alt="" /></a>'.
-		'</form>'.
+		'<p><a href="'.$core->blog->url.'" onclick="window.open(this.href);return false;" title="'.__('Go to site').' ('.__('new window').')'.'">'.__('Go to site').' <img src="images/outgoing.png" alt="" /></a>'.
+		'</p></form>'.
 		'</div>'.
 		'<div id="info-box2">'.
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 1013)
+++ inc/admin/prepend.php	(revision 962)
@@ -375,17 +375,3 @@
 	}
 }
-
-# Creating template context
-try {
-	$core->page = new dcTwigPage(
-		dirname(__FILE__).'/default-templates',
-		DC_TPL_CACHE.'/admtpl',
-		new dcAdminContext($core),
-		$core
-	);
-} catch (Exception $e) {
-	__error(__('Can\'t create template engine.')
-		,$e->getMessage()
-		,640);
-}
 ?>
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 970)
+++ inc/core/class.dc.blog.php	(revision 1015)
@@ -1339,4 +1339,31 @@
 	
 	/**
+	Updates posts category. <var>$new_cat_id</var> can be null.
+	
+	@param	old_cat_id	<b>integer</b>		Old category ID
+	@param	new_cat_id	<b>integer</b>		New category ID
+	*/
+	public function updPostsCategory($old_cat_id,$new_cat_id)
+	{
+		if (!$this->core->auth->check('contentadmin,categories',$this->id)) {
+			throw new Exception(__('You are not allowed to change entries category'));
+		}
+		
+		$old_cat_id = (integer) $old_cat_id;
+		$new_cat_id = (integer) $new_cat_id;
+		
+		$cur = $this->con->openCursor($this->prefix.'post');
+		
+		$cur->cat_id = ($new_cat_id ? $new_cat_id : null);
+		$cur->post_upddt = date('Y-m-d H:i:s');
+		
+		$cur->update(
+			'WHERE cat_id = '.$old_cat_id.' '.
+			"AND blog_id = '".$this->con->escape($this->id)."' "
+		);
+		$this->triggerBlog();
+	}
+	
+	/**
 	Deletes a post.
 	
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 1014)
+++ inc/prepend.php	(revision 1011)
@@ -12,5 +12,5 @@
 
 /* ------------------------------------------------------------------------------------------- */
-#  ClearBricks, Twig, DotClear classes auto-loader
+#  ClearBricks, DotClear classes auto-loader
 if (@is_dir('/usr/lib/clearbricks')) {
 	define('CLEARBRICKS_PATH','/usr/lib/clearbricks');
@@ -46,5 +46,4 @@
 $__autoload['dcWorkspace']			= dirname(__FILE__).'/core/class.dc.workspace.php';
 $__autoload['dcPrefs']				= dirname(__FILE__).'/core/class.dc.prefs.php';
-$__autoload['dcTwigPage']			= dirname(__FILE__).'/core/class.dc.twig.page.php';
 
 $__autoload['rsExtPost']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
@@ -53,5 +52,4 @@
 $__autoload['rsExtUser']				= dirname(__FILE__).'/core/class.dc.rs.extensions.php';
 
-$__autoload['dcAdminContext']				= dirname(__FILE__).'/admin/class.dc.admincontext.php';
 $__autoload['dcMenu']				= dirname(__FILE__).'/admin/class.dc.menu.php';
 $__autoload['dcPage']				= dirname(__FILE__).'/admin/lib.dc.page.php';
@@ -65,25 +63,8 @@
 $__autoload['context']				= dirname(__FILE__).'/public/lib.tpl.context.php';
 $__autoload['dcUrlHandlers']			= dirname(__FILE__).'/public/lib.urlhandlers.php';
-$__autoload['dcForm']			= dirname(__FILE__).'/admin/class.dc.form.php';
-$__autoload['dcFormExtension']			= dirname(__FILE__).'/admin/class.dc.form.php';
 
 # Clearbricks extensions
 html::$absolute_regs[] = '/(<param\s+name="movie"\s+value=")(.*?)(")/msu';
 html::$absolute_regs[] = '/(<param\s+name="FlashVars"\s+value=".*?(?:mp3|flv)=)(.*?)(&|")/msu';
-
-if (@is_dir('/usr/lib/twig')) {
-	define('TWIG_PATH','/usr/lib/twig');
-} elseif (is_dir(dirname(__FILE__).'/libs/twig')) {
-	define('TWIG_PATH',dirname(__FILE__).'/libs/twig');
-} elseif (isset($_SERVER['TWIG_PATH']) && is_dir($_SERVER['TWIG_PATH'])) {
-	define('TWIG_PATH',$_SERVER['TWIG_PATH']);
-}
-
-if (!defined('TWIG_PATH') || !is_dir(TWIG_PATH)) {
-	exit('No Twig path defined');
-}
-require TWIG_PATH.'/Autoloader.php';
-Twig_Autoloader::register();
-
 /* ------------------------------------------------------------------------------------------- */
 
